# Summary

- [Overview](README.md)
- [Instructions](howto/README.md)
  - [How to map on-street parking](howto/map_parking.md)
  - [Importing a new city](howto/new_city.md)
- [How it works](how_it_works.md)
- [Case studies](case_studies/README.md)
  - [Lake Washington Blvd Stay Healthy Street](case_studies/lake_wash.md)
  - [West Seattle mitigations](case_studies/west_seattle.md)

---

- [Developer guide](dev/README.md)
  - [Misc developer tricks](dev/misc_tricks.md)
  - [API](dev/api.md)
  - [Testing](dev/testing.md)
- [Map model](map/README.md)
  - [Importing](map/importing/README.md)
    - [convert_osm](map/importing/convert_osm.md)
    - [Road/intersection geometry](map/importing/geometry.md)
    - [The rest](map/importing/rest.md)
  - [Live edits](map/edits.md)
  - [Misc](map/misc.md)
  - [Exporting](map/platform.md)
- [Traffic simulation](trafficsim/README.md)
  - [Discrete event simulation](trafficsim/discrete_event.md)
  - [Travel demand](trafficsim/travel_demand.md)
  - [Gridlock](trafficsim/gridlock.md)
  - [Multi-modal trips](trafficsim/trips.md)
  - [Live edits](trafficsim/live_edits.md)
  - [Parking](trafficsim/parking.md)

---

- [Project](project/README.md)
  - [Roadmap](project/roadmap.md)
  - [Motivations](project/motivations.md)
  - [History](project/history/README.md)
    - [Backstory](project/history/backstory.md)
    - [Year 1](project/history/year1.md)
    - [Year 2](project/history/year2.md)
    - [Year 3](project/history/year3.md)
  - [Full CHANGELOG](project/CHANGELOG.md)
  - [References](project/references.md)
  - [Collaborations](project/collaborations.md)
