# Project motivations

I thought it'd be helpful to explain what motivates my work in A/B Street. These
are just my personal values; I don't intend to make a careful argument about
these here. In no particular order:

- **Transparency and reproducibility**: if city government uses data, modeling,
  or simulation to inform a decision affecting the general public, then anybody
  ought to be able to repeat that analysis.

  - This means code and data should be open.
  - Businesses like [Sidewalk Lab's Replica](https://replicahq.com/) and
    [Remix](https://www.remix.com/solutions/streets) still need to generate
    income, but it's unclear why governments use taxes to pay for something only
    they see.
  - Decision making should be documented clearly. Why were the
    [35th Ave bike lanes](https://www.seattle.gov/transportation/projects-and-programs/programs/maintenance-and-paving/current-paving-projects/35th-ave-ne)
    scrapped? Was the amount of on-street parking on nearby residential roads
    factored in? Was there analysis of how trip time is impacted by parking in
    the neighborhood and walking a few blocks to a business on the arterial?
  - I'm personally inspired by approaches like
    [vTaiwan](https://info.vtaiwan.tw/) and
    [PDIS](https://po.pdis.nat.gov.tw/en/opengov/)

- **Accessibility leads to participation**: There's overhead to taking small
  ideas to advocacy groups or inconveniently timed public meetings. If the
  planning process is easier to interact with, more people will participate.

  - Seattle's
    [Your Voice, Your Choice](https://www.seattle.gov/neighborhoods/programs-and-services/your-voice-your-choice)
    program is maybe an example of this

- **Short-term changes**: [ST3](https://en.wikipedia.org/wiki/Sound_Transit_3)
  is exciting, but 2040 isn't close. There are much cheaper changes that can be
  implemented sooner.

  - Most of the edits in A/B Street are inspired by tactical urbanism; they
    could be prototyped with signs and paint.

- **The US is too dependent on cars**: This has an unacceptable impact on the
  environment. Even ignoring that, many cities are out of room to build more
  roads. We can't keep scaling population like this.

- **Autonomous vehicles will NOT save the day**: They can squeeze more
  throughput out of existing infrastructure, but only up to a point. They might
  encourage people to move and tolerate longer commutes. Mass transit and dense
  land-use patterns handle population growth better.

- **Compromise and trade-offs**: I see lots of rhetoric calling for extreme,
  sudden change. I don't want to ban all cars from downtown Seattle, because
  that's not realistic. I want to focus on immediate steps forward. I want to
  come up with estimates about impacting drivers by a median 3 minutes in order
  to save a bus route 1 minute, and to shift public discourse towards that.
